/**
 * COCTMT440001UVValuedItem.java
 *
 * File generated from the medication::COCTMT440001UVValuedItem uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class COCTMT440001UVValuedItem.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "COCT_MT440001UV.ValuedItem", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"effectiveTime",
	"unitQuantity",
	"unitPriceAmt",
	"netAmt",
	"classCode",
	"moodCode"
})
@XmlRootElement(name = "COCT_MT440001UV.ValuedItem")
public class COCTMT440001UVValuedItem implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId;
	@XmlElement(name = "id", required = true, namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.II> id;
	@XmlElement(name = "code", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CD code;
	@XmlElement(name = "effectiveTime", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.IVLTS effectiveTime;
	@XmlElement(name = "unitQuantity", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.RTOPQPQ unitQuantity;
	@XmlElement(name = "unitPriceAmt", required = true, namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.RTOMOPQ unitPriceAmt;
	@XmlElement(name = "netAmt", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.MO netAmt;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.medication.ActClassInvoiceElement classCode;
	@XmlAttribute(name = "moodCode", required = true)
	public net.ihe.gazelle.medication.XActMoodDefEvn moodCode;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.medication.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.medication.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.medication.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.medication.II id_elt) {
	    this.id.add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.medication.II id_elt) {
	    this.id.remove(id_elt);
	}
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.medication.CD getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.medication.CD code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return effectiveTime.
	 * @return effectiveTime
	 */
	public net.ihe.gazelle.medication.IVLTS getEffectiveTime() {
	    return effectiveTime;
	}
	
	/**
	 * Set a value to attribute effectiveTime.
	 * @param effectiveTime.
	 */
	public void setEffectiveTime(net.ihe.gazelle.medication.IVLTS effectiveTime) {
	    this.effectiveTime = effectiveTime;
	}
	
	
	
	
	/**
	 * Return unitQuantity.
	 * @return unitQuantity
	 */
	public net.ihe.gazelle.medication.RTOPQPQ getUnitQuantity() {
	    return unitQuantity;
	}
	
	/**
	 * Set a value to attribute unitQuantity.
	 * @param unitQuantity.
	 */
	public void setUnitQuantity(net.ihe.gazelle.medication.RTOPQPQ unitQuantity) {
	    this.unitQuantity = unitQuantity;
	}
	
	
	
	
	/**
	 * Return unitPriceAmt.
	 * @return unitPriceAmt
	 */
	public net.ihe.gazelle.medication.RTOMOPQ getUnitPriceAmt() {
	    return unitPriceAmt;
	}
	
	/**
	 * Set a value to attribute unitPriceAmt.
	 * @param unitPriceAmt.
	 */
	public void setUnitPriceAmt(net.ihe.gazelle.medication.RTOMOPQ unitPriceAmt) {
	    this.unitPriceAmt = unitPriceAmt;
	}
	
	
	
	
	/**
	 * Return netAmt.
	 * @return netAmt
	 */
	public net.ihe.gazelle.medication.MO getNetAmt() {
	    return netAmt;
	}
	
	/**
	 * Set a value to attribute netAmt.
	 * @param netAmt.
	 */
	public void setNetAmt(net.ihe.gazelle.medication.MO netAmt) {
	    this.netAmt = netAmt;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.medication.ActClassInvoiceElement getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.medication.ActClassInvoiceElement classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.medication.XActMoodDefEvn getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.medication.XActMoodDefEvn moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "COCT_MT440001UV.ValuedItem").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(COCTMT440001UVValuedItem cOCTMT440001UVValuedItem, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cOCTMT440001UVValuedItem != null){
   			cvm.validate(cOCTMT440001UVValuedItem, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: cOCTMT440001UVValuedItem.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.infr.AllInfrastructureRootTypeId.validateByModule(cOCTMT440001UVValuedItem.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId: cOCTMT440001UVValuedItem.getTemplateId()){
					net.ihe.gazelle.infr.AllInfrastructureRootTemplateId.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.II id: cOCTMT440001UVValuedItem.getId()){
					net.ihe.gazelle.medication.II.validateByModule(id, location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.CD.validateByModule(cOCTMT440001UVValuedItem.getCode(), location + "/code", cvm, diagnostic);
			net.ihe.gazelle.medication.IVLTS.validateByModule(cOCTMT440001UVValuedItem.getEffectiveTime(), location + "/effectiveTime", cvm, diagnostic);
			net.ihe.gazelle.medication.RTOPQPQ.validateByModule(cOCTMT440001UVValuedItem.getUnitQuantity(), location + "/unitQuantity", cvm, diagnostic);
			net.ihe.gazelle.medication.RTOMOPQ.validateByModule(cOCTMT440001UVValuedItem.getUnitPriceAmt(), location + "/unitPriceAmt", cvm, diagnostic);
			net.ihe.gazelle.medication.MO.validateByModule(cOCTMT440001UVValuedItem.getNetAmt(), location + "/netAmt", cvm, diagnostic);
    	}
    }

}